/*
-------------------------------------------------------------------------------
                                I   M   L   I   B
				       1.1
-------------------------------------------------------------------------------

This software is Copyright (C) 1998 By The Rasterman (Carsten Haitzler). I
accept no responsability for anythign this software may or may not do to
your system - you use it completely at your own risk. This software comes
under the LGPL and GPL licences. The library itself is LGPL (all software in
Imlib and gdk_imlib directories) see the COPYING and COPYING.LIB files for
full legal details.
*/

#include "gdk_imlib.h"
#include "gdk_imlib_private.h"

void calc_map_tables(GdkImlibImage *im)
{
   int    i;
   double g,b,c,ii,v;
   
   if (!im) return;

   g=((double)im->mod.gamma)/256;
   b=((double)im->mod.brightness)/256;
   c=((double)im->mod.contrast)/256;
   for(i=0;i<256;i++)
     {
	ii=((double)i)/256;
	v=pow(((ii-0.5)*c)+0.5+(b-1),1/g)*256;
	if (v>255) v=255;
	else if (v<0) v=0;
	im->rmap[i]=(unsigned char)v;
	im->gmap[i]=(unsigned char)v;
	im->bmap[i]=(unsigned char)v;
     }
   g=((double)im->rmod.gamma)/256;
   b=((double)im->rmod.brightness)/256;
   c=((double)im->rmod.contrast)/256;
   for(i=0;i<256;i++)
     {
	ii=((double)im->rmap[i])/256;
	v=pow(((ii-0.5)*c)+0.5+(b-1),1/g)*256;
	if (v>255) v=255;
	else if (v<0) v=0;
	im->rmap[i]=(unsigned char)v;
     }
   g=((double)im->gmod.gamma)/256;
   b=((double)im->gmod.brightness)/256;
   c=((double)im->gmod.contrast)/256;
   for(i=0;i<256;i++)
     {
	ii=((double)im->gmap[i])/256;
	v=pow(((ii-0.5)*c)+0.5+(b-1),1/g)*256;
	if (v>255) v=255;
	else if (v<0) v=0;
	im->gmap[i]=(unsigned char)v;
     }
   g=((double)im->bmod.gamma)/256;
   b=((double)im->bmod.brightness)/256;
   c=((double)im->bmod.contrast)/256;
   for(i=0;i<256;i++)
     {
	ii=((double)im->bmap[i])/256;
	v=pow(((ii-0.5)*c)+0.5+(b-1),1/g)*256;
	if (v>255) v=255;
	else if (v<0) v=0;
	im->bmap[i]=(unsigned char)v;
     }
}

void nullify_image(GdkImlibImage *im)
{
   if (!im) return;
   if (im->rgb_data) free(im->rgb_data);
   if (im->alpha_data) free(im->alpha_data);
   if (im->pixmap) free_pixmappmap(im->pixmap);
   if (im->filename) free(im->filename);
   free(im);
}

void free_pixmappmap(GdkPixmap *pmap)
{
   gdk_pixmap_unref(pmap);
}

